#include <gtk/gtk.h>
#include <glade/glade.h>
#include "kf.h"

static void kf_config_dir (void);

const gchar *kf_find_file (const gchar *name) {
	static gchar text[1024];

	g_snprintf (text, 1024, "../data/%s", name);
	if (g_file_test (text, G_FILE_TEST_EXISTS))
		return text;

	g_snprintf (text, 1024, "%s/kf/%s", PACKAGE_DATA_DIR, name);
	return text;
}

const gchar *kf_config_file (const gchar *name) {
	static gchar path[1024];

	kf_config_dir ();
	g_snprintf (path, 1024, "%s/.kf/%s", g_get_home_dir (), name);
	return path;
}

gint kf_signal_connect (GladeXML *glade, const gchar *name, const gchar *signal, GCallback *callback,
		gpointer data) {
	GtkWidget *widget;

	widget = glade_xml_get_widget (glade, name);
	if (widget) {
		return g_signal_connect (G_OBJECT (widget), signal, callback, data);
	} else {
		return -1;
	}
}

static void kf_config_dir (void) {
	static gchar path[1024];

	g_snprintf (path, 1024, "%s/.kf", g_get_home_dir ());
	mkdir (path, 00753);
}


