#include <gtk/gtk.h>
#include <glade/glade.h>
#include <loudmouth/loudmouth.h>
#include <string.h>
#include "x_data.h"
/*
typedef enum {
	KF_X_DATA_TEXT_SINGLE,
	KF_X_DATA_TEXT_PRIVATE,
	KF_X_DATA_TEXT_MULTI,
	KF_X_DATA_LIST_SINGLE,
	KF_X_DATA_LIST_MULTI,
	KF_X_DATA_BOOLEAN,
	KF_X_DATA_FIXED,
	KF_X_DATA_HIDDEN,
	KF_X_DATA_JID_SINGLE,
	KF_X_DATA_JID_MULTI
} KfXDataType;
*/
KfXDataType kf_x_data_type_from_string (const gchar *str);
static GtkWidget *kf_x_data_create_list 
	(GtkWidget *table, const gchar *title,
	 KfXDataType type, LmMessageNode *node, guint field_id);
static GtkWidget *kf_x_data_create_boolean 
	(GtkWidget *table, const gchar *title,
	 KfXDataType type, LmMessageNode *node, guint field_id);
static const gchar *get_value (KfXDataType type, GtkWidget *widget);
static const gchar *get_value_list_single (GtkWidget *widget);

GtkWidget *kf_x_data_form (LmMessageNode *node) {
	GtkWidget *table;
	guint field_id = 2;
	GSList *list = NULL;
//	GtkWidget *desc;
//	GtkWidget *field;

	table = gtk_table_new (2, 2, FALSE);
	gtk_table_set_row_spacings (GTK_TABLE (table), 6);
	gtk_table_set_col_spacings (GTK_TABLE (table), 6);

	while (node) {
//		KfXDataType type;

//		type = kf_x_data_type_from_string (node->name);

		if (!strcmp (node->name, "title")) {
			GtkWidget *label;

			label = gtk_label_new (lm_message_node_get_value (node));
			gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
			gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 2, 0, 1);
		} else if (!strcmp (node->name, "instructions")) {
			GtkWidget *label;

			label = gtk_label_new (lm_message_node_get_value (node));
			gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
			gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 2, 1, 2);
		} else if (!strcmp (node->name, "field")) {
			LmMessageNode *value_node;
			const gchar *title; /* label */
			const gchar *type_str;
			const gchar *var;
			const gchar *value;
			KfXDataType type;


			title = lm_message_node_get_attribute (node, "label");
			type_str = lm_message_node_get_attribute (node, "type");
			var = lm_message_node_get_attribute (node, "var");
			value_node = lm_message_node_get_child (node, "value");
			value = (value_node)?lm_message_node_get_value (value_node):NULL;
			
			type = kf_x_data_type_from_string (type_str);
			
			if (type == KF_X_DATA_FIXED && value) {
				/* Po prostu label */
				GtkWidget *label;
				
				label = gtk_label_new (value);
			 	gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
//				gtk_table_resize (GTK_TABLE (table), 2, field_id+1);
				gtk_table_attach_defaults (GTK_TABLE (table), label,
						0, 2, field_id, field_id+1);
				field_id++;
			} else if (	   type == KF_X_DATA_TEXT_SINGLE
					|| type == KF_X_DATA_TEXT_PRIVATE
					|| type == KF_X_DATA_JID_SINGLE
					|| type == KF_X_DATA_JID_MULTI) {
				GtkWidget *label;
				GtkWidget *entry;
				
				label = gtk_label_new (title);
			 	gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
				entry = gtk_entry_new ();
				if (type == KF_X_DATA_TEXT_PRIVATE) {
					gtk_entry_set_visibility (GTK_ENTRY (entry), FALSE);
				}
				if (value) {
					gtk_entry_set_text (GTK_ENTRY (entry), value);
				}
				gtk_table_attach_defaults (GTK_TABLE (table), label,
						0, 1, field_id, field_id+1);
				gtk_table_attach_defaults (GTK_TABLE (table), entry,
						1, 2, field_id, field_id+1);
				field_id++;
				list = g_slist_append (list, 
						kf_x_data_field_new (type, var, entry));
			} else if (type == KF_X_DATA_TEXT_MULTI) {
				/* Multiline text edit */
				GtkWidget *label;
				GtkWidget *tv;

				tv = gtk_tree_view_new ();
				label = gtk_label_new (title);
			 	gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
				gtk_table_attach_defaults (GTK_TABLE (table), label,
						0, 1, field_id, field_id+1);
				gtk_table_attach_defaults (GTK_TABLE (table), tv,
						1, 2, field_id, field_id+1);
				field_id++;
				list = g_slist_append (list, 
						kf_x_data_field_new (type, var, tv));
			} else if (type == KF_X_DATA_LIST_SINGLE) {
				GtkWidget *widget;
				widget = kf_x_data_create_list (table, title, type, node, field_id++);
				list = g_slist_append (list, 
						kf_x_data_field_new (type, var, widget));
			/*	GtkWidget *label;
				GtkWidget *vbox;
				GtkWidget *opt = NULL;
				LmMessageNode *child;

				label = gtk_label_new (title);
			 	gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
				vbox = gtk_vbox_new (FALSE, 0);

				child = node->children;
				while (child) {
					gchar *text;
					
					text = lm_message_node_get_attribute (child, "label");

					if (opt)
						opt = gtk_radio_button_new_with_label_from_widget
							(opt, text);
					else
						opt = gtk_radio_button_new_with_label
							(NULL, text);

					gtk_box_pack_start_defaults (GTK_BOX (vbox), opt);

					child = child->next;
				}
				
				gtk_table_attach_defaults (GTK_TABLE (table), label,
						0, 1, field_id, field_id+1);
				gtk_table_attach_defaults (GTK_TABLE (table), vbox,
						1, 2, field_id, field_id+1);
				field_id++;*/
			} else if (type == KF_X_DATA_BOOLEAN) {
				GtkWidget *widget;
				widget = kf_x_data_create_boolean (table, title, type, node, field_id++);
				if (value && *value == '1')
					gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
				list = g_slist_append (list, 
						kf_x_data_field_new (type, var, widget));
			} else if (type == KF_X_DATA_HIDDEN) {
				LmMessageNode *value_node;
				const gchar *value;
				GtkWidget *widget;
				
				value_node = lm_message_node_get_child (node, "value");
				if (value_node)
					value = g_strdup (value_node->value);
				widget = gtk_label_new (value);
				gtk_table_attach_defaults (GTK_TABLE (table), widget,
					0, 1, field_id, field_id+1);
				field_id++;

				list = g_slist_append (list, 
						kf_x_data_field_new (type, var, widget));
			}
		}
		
		node = node->next;
	}
	g_object_set_data (G_OBJECT (table), "Fields", (gpointer) list);
	return table;
}

static GtkWidget *kf_x_data_create_list 
	(GtkWidget *table, const gchar *title,
	 KfXDataType type, LmMessageNode *node, guint field_id) {
	GtkWidget *label;
	GtkWidget *vbox;
	GtkWidget *opt = NULL;
	LmMessageNode *child;

	label = gtk_label_new (title);
 	gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
	vbox = gtk_vbox_new (FALSE, 0);

	child = node->children;
	while (child) {
		LmMessageNode *value_node;
		const gchar *text;
		const gchar *value;
		
		if (strcmp (child->name, "option")) {
			child = child->next;
			continue;
		}
		
		text = lm_message_node_get_attribute (child, "label");
		value_node = lm_message_node_get_child (child, "value");
		if (value_node)
			value = g_strdup (value_node->value);

		if (type == KF_X_DATA_LIST_MULTI) {
			opt = gtk_toggle_button_new_with_label (text);
		} else {
			if (opt)
				opt = gtk_radio_button_new_with_label_from_widget
					(opt, text);
			else
				opt = gtk_radio_button_new_with_label
					(NULL, text);
		}
		g_object_set_data_full (G_OBJECT (opt), "value", value, g_free);

		gtk_box_pack_start_defaults (GTK_BOX (vbox), opt);

		child = child->next;
	}
	
	gtk_table_attach_defaults (GTK_TABLE (table), label,
			0, 1, field_id, field_id+1);
	gtk_table_attach_defaults (GTK_TABLE (table), vbox,
			1, 2, field_id, field_id+1);
	return vbox;
}

static GtkWidget *kf_x_data_create_boolean 
	(GtkWidget *table, const gchar *title,
	 KfXDataType type, LmMessageNode *node, guint field_id)
{
	GtkWidget *label;
	GtkWidget *toggle;
	toggle = gtk_toggle_button_new_with_label (title);
	gtk_table_attach_defaults (GTK_TABLE (table), toggle,
		1, 2, field_id, field_id+1);
	return toggle;
}


KfXDataType kf_x_data_type_from_string (const gchar *type) {
//	KfXDataType type;

	if (!strcmp (type, "text-single"))
		return KF_X_DATA_TEXT_SINGLE;
	else if (!strcmp (type, "text-private"))
		return KF_X_DATA_TEXT_PRIVATE;
	else if (!strcmp (type, "text-multi"))
		return KF_X_DATA_TEXT_MULTI;
	else if (!strcmp (type, "list-single"))
		return KF_X_DATA_LIST_SINGLE;
	else if (!strcmp (type, "list-multi"))
		return KF_X_DATA_LIST_MULTI;
	else if (!strcmp (type, "boolean"))
		return KF_X_DATA_BOOLEAN;
	else if (!strcmp (type, "fixed"))
		return KF_X_DATA_FIXED;
	else if (!strcmp (type, "hidden"))
		return KF_X_DATA_HIDDEN;
	else if (!strcmp (type, "jid-single"))
		return KF_X_DATA_JID_SINGLE;
	else if (!strcmp (type, "jid-multi"))
		return KF_X_DATA_JID_MULTI;

//	return type;
}

KfXDataField *kf_x_data_field_new (KfXDataType type,
	const gchar *var,
	GtkWidget *widget) {
	KfXDataField *field;

	field = g_new (KfXDataField, 1);

	field->type = type;
	field->var = g_strdup (var);
	field->widget = widget;

	return field;
}

void kf_x_data_field_free (KfXDataField *field) {
	g_free (field->var);
	g_free (field);
}

LmMessageNode *kf_x_data_create_node (LmMessageNode *parent, GSList *list) {
	LmMessageNode *pnode = lm_message_node_add_child (parent, "x", NULL);
	lm_message_node_set_attribute (pnode, "xmlns", "jabber:x:data");
	lm_message_node_set_attribute (pnode, "type", "submit");
	while (list) {
		KfXDataField *field;
		const gchar *text;
		LmMessageNode *node;

		field = list->data;
		text = get_value (field->type, field->widget);

	//	g_print ("<field var='%s'><value>%s</value></field>\n", field->var, text);
		node = lm_message_node_add_child (pnode, "field", NULL);
		lm_message_node_set_attribute (node, "var", field->var);
		lm_message_node_add_child (node, "value", text);
		if (field->type == KF_X_DATA_TEXT_MULTI)
			g_free (field->var);
		list = list->next;
	}
	return;
}

static const gchar *get_value (KfXDataType type, GtkWidget *widget) {
	switch (type) {
		case KF_X_DATA_TEXT_SINGLE:
		case KF_X_DATA_TEXT_PRIVATE:
		case KF_X_DATA_JID_SINGLE:
		case KF_X_DATA_JID_MULTI:
			return gtk_entry_get_text (GTK_ENTRY (widget));
			break;
		case KF_X_DATA_LIST_SINGLE:
			return get_value_list_single (widget);
		case KF_X_DATA_BOOLEAN:
			return gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget))?"1":"0";
		case KF_X_DATA_TEXT_MULTI:
			if (1) {
			GtkTextBuffer *buffer;
			GtkTextIter start, end;

			buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (buffer));
			gtk_text_buffer_get_bounds (buffer, &start, &end);
			return gtk_text_buffer_get_text (buffer, &start, &end, FALSE);
			}
		default:
			return NULL;
	}
}

static const gchar *get_value_list_single (GtkWidget *widget) {
	GList *list = GTK_BOX (widget)->children;
	GtkBoxChild *child;
	while (list) {
		GtkRadioButton *opt;
		
		child = list->data;
		opt = GTK_RADIO_BUTTON (child->widget);
		if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (opt))) {
			return (gchar *) g_object_get_data (G_OBJECT (opt), "value");
		}
		list = list->next;
	}
	return NULL;
}
